#include "BMP280.H"
#include "reg51.h"
#include "IIC.h"	

unsigned short dig_T1;
short dig_T2;
short dig_T3;
unsigned short dig_P1;
short dig_P2;
short dig_P3;
short dig_P4;
short dig_P5;
short dig_P6;
short dig_P7;
short dig_P8;
short dig_P9;

void Bmp280_delay_ms(int x)
{
	int y;
	for(x;x>0;x--)
		for(y=1100;y>0;y--);
}

unsigned char BMP280_ReadByte(unsigned char addr)//BMP280һֽ
{
	unsigned char temp;
	I2C_start_slow();
	I2C_send_byte_slow(BMP280_ADDR);
	Test_ack_slow();
	I2C_send_byte_slow(addr);
	Test_ack_slow();
	
	I2C_start_slow();
	I2C_send_byte_slow(BMP280_ADDR+1);
	Test_ack_slow();
	temp=I2C_read_byte_slow();
	I2C_SendACK_slow(1);
	I2C_stop_slow();
	
	return temp;	
}

void BMP280_WriteByte(unsigned char addr, unsigned char dat)//BMP280дһֽ
{
	I2C_start_slow();
	I2C_send_byte_slow(BMP280_ADDR);
	Test_ack_slow();
	I2C_send_byte_slow(addr);
	Test_ack_slow();
	I2C_send_byte_slow(dat);
	Test_ack_slow();
	I2C_stop_slow();	
}

long BMP280_MultipleReadThree(unsigned char addr)	
{
    unsigned char msb, lsb, xlsb;
    long temp = 0;
    msb = BMP280_ReadByte(addr);
    lsb = BMP280_ReadByte(addr + 1);
    xlsb = BMP280_ReadByte(addr + 2);

    temp = (long)(((unsigned long)msb << 12)|((unsigned long)lsb << 4)|((unsigned long)xlsb >> 4));

    return temp;
}

short BMP280_MultipleReadTwo(unsigned char addr)
{
    unsigned char msb, lsb;
    short temp = 0;
    lsb = BMP280_ReadByte(addr);
    msb = BMP280_ReadByte(addr + 1);

    temp = (short)msb << 8;
    temp |= (short)lsb;

    return temp;
}

void BMP280_Init(void)
{
    unsigned char temp = 0;
  
		BMP280_WriteByte(BMP280_RESET,0xB6);//״̬ȫ

    BMP280_WriteByte(BMP280_CTRL_MEAS, 0xFF);	//ȫ20bit
    BMP280_WriteByte(BMP280_CONFIG, 0x00);		//0.5ms
    dig_T1 = BMP280_MultipleReadTwo(0x88);	//ֵ
    dig_T2 = BMP280_MultipleReadTwo(0x8A);
    dig_T3 = BMP280_MultipleReadTwo(0x8C);
    dig_P1 = BMP280_MultipleReadTwo(0x8E);
    dig_P2 = BMP280_MultipleReadTwo(0x90);
    dig_P3 = BMP280_MultipleReadTwo(0x92);
    dig_P4 = BMP280_MultipleReadTwo(0x94);
    dig_P5 = BMP280_MultipleReadTwo(0x96);
    dig_P6 = BMP280_MultipleReadTwo(0x98);
    dig_P7 = BMP280_MultipleReadTwo(0x9A);
    dig_P8 = BMP280_MultipleReadTwo(0x9C);
    dig_P9 = BMP280_MultipleReadTwo(0x9E);

    Bmp280_delay_ms(200);        
}

long bmp280_GetPres(void)
{
    long adc_T;
    long adc_P;
    long var1, var2, t_fine, T, p;
    adc_T = BMP280_MultipleReadThree(BMP280_TEMP_ADDR);
    adc_P = BMP280_MultipleReadThree(BMP280_PRESS_ADDR);

    if(adc_P == 0)
    {
        return 0;
    }

    //Temperature
    var1 = (((double)adc_T)/16384.0-((double)dig_T1)/1024.0)*((double)dig_T2);
    var2 = ((((double)adc_T)/131072.0-((double)dig_T1)/8192.0)*(((double)adc_T)
                /131072.0-((double)dig_T1)/8192.0))*((double)dig_T3);

    t_fine = (unsigned long)(var1+var2);

    T = (var1+var2)/5120.0;

		//presure
    var1 = ((double)t_fine/2.0)-64000.0;
    var2 = var1*var1*((double)dig_P6)/32768.0;
    var2 = var2 +var1*((double)dig_P5)*2.0;
    var2 = (var2/4.0)+(((double)dig_P4)*65536.0);
    var1 = (((double)dig_P3)*var1*var1/524288.0+((double)dig_P2)*var1)/524288.0;
    var1 = (1.0+var1/32768.0)*((double)dig_P1);
    p = 1048576.0-(double)adc_P;
    p = (p-(var2/4096.0))*6250.0/var1;
    var1 = ((double)dig_P9)*p*p/2147483648.0;
    var2 = p*((double)dig_P8)/32768.0;
    p = p+(var1+var2+((double)dig_P7))/16.0;

    return p;
}

long bmp280_GetTemp(void)
{
	  long adc_T;
    long var1, var2, T;
    adc_T = BMP280_MultipleReadThree(BMP280_TEMP_ADDR);
	
	    //Temperature
    var1 = (((double)adc_T)/16384.0-((double)dig_T1)/1024.0)*((double)dig_T2);
    var2 = ((((double)adc_T)/131072.0-((double)dig_T1)/8192.0)*(((double)adc_T)
                /131072.0-((double)dig_T1)/8192.0))*((double)dig_T3);

    T = (var1+var2)/5120.0;
		return T;
}