#include <MPU6050.H>
#include <IIC.H>

void MPU6050_write(unsigned char addr,unsigned char dat)
{
	I2C_start();
	I2C_send_byte(MPU6050_Addr);
	Test_ack();
	I2C_send_byte(addr);
	Test_ack();
	I2C_send_byte(dat);
	Test_ack();	
	I2C_stop();	
}

unsigned char  MPU6050_read(unsigned char addr)
{
	unsigned char temp;
	I2C_start();	
	I2C_send_byte(MPU6050_Addr);
	Test_ack();
	I2C_send_byte(addr);	
	Test_ack();		

	I2C_start();	
	I2C_send_byte(MPU6050_Addr+1);	
	Test_ack();		
	temp=I2C_read_byte();
	I2C_SendACK(1);
	I2C_stop();
	
	return temp;
}

void MPU6050_init()
{
	I2C_init();
	MPU6050_write(PWR_MGMT_1, 0x00);        //״̬
	MPU6050_write(SMPLRT_DIV, 0x07);
  MPU6050_write(CONFIG, 0x06);
  MPU6050_write(GYRO_CONFIG, 0x18);
  MPU6050_write(ACCEL_CONFIG, 0x01);
}

int MPU6050_GetData(unsigned char REG_Address)
{
	char H,L;
	H=MPU6050_read(REG_Address);
	L=MPU6050_read(REG_Address+1);
	return (H<<8)+L;   //ϳ
}


