#include <reg51.h>
#include <intrins.h>
#include "OLED_12864.h"
#include <ADS1015.H>
#include <DAC4725.H>
#include "BH1750.H"
#include "BMP280.H"
#include <MPU6050.H>
#include <mini1602.h>

//ʹõƬSTC8A8K64S4A12
//ϵͳʱ@24Mhz

#define DIG_DATA P2				//˿ڶ岿

sbit led_r=P1^0;
sbit led_g=P1^1;
sbit led_b=P1^2;

sbit SER=P3^2;
sbit CLK=P3^0; 
sbit OUT=P3^1;

sbit DIG0=P0^0;
sbit DIG1=P0^1;
sbit DIG2=P0^2;
sbit DIG3=P0^3;

sbit key2=P3^2;

sbit BEE=P1^7;
unsigned int num=200;

bit flag;
unsigned char code LED[9]={
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x00
};

unsigned char code SMG[17]={
0x14,0x77,0x4C,0x45,0x27,0x85,0x84,0x57,0x04,0x05,	//0-9
0x06,0xA4,0x9C,0x64,0x8C,0x8E,0XFF				//A-F
};

void delayms(unsigned int x)	//ʱ
{
	unsigned int y;
	for(x;x>0;x--)
		for(y=1000;y>0;y--);
}

void t0_init()	//ϵͳʱ@24Mhz
{
	TMOD=0x01;
	TH0=0X3C;
	TL0=0XAF;
	ET0=1;
	EA=1;
	TR0=1;
}

void SendByte_595(unsigned char dat)	//595дһֽ
{
	unsigned char i;
	CLK=0;
	OUT=0;
	for(i=0;i<8;i++)
	{
		SER=dat>>7;
		CLK=1;
		_nop_();
		CLK=0;
		dat<<=1;
	}
	OUT=1;
	_nop_();
	OUT=0;
}

void welcome()
{
	OLED12864_ShowStr(0,0,"This is OLED demo    ",1);
	OLED12864_ShowStr(0,3,"Hello World! ",2);	
}

void led_flow()
{
	unsigned char i;
	OLED12864_ShowStr(0,0,"This is LED demo     ",1);
	for(i=0;i<9;i++)
	{
		SendByte_595(LED[i]);
		delayms(100);
	}
	BEE=0;
	delayms(30);
	BEE=1;
}

void SMG_disp()
{
	OLED12864_ShowStr(0,0,"This is SMG demo     ",1);
		DIG0=0;DIG1=0;DIG2=0;DIG3=1;
	DIG_DATA=SMG[0];
	delayms(1);
		DIG0=0;DIG1=0;DIG2=1;DIG3=0;
	DIG_DATA=SMG[1];
	delayms(1);
		DIG0=0;DIG1=1;DIG2=0;DIG3=0;
	DIG_DATA=SMG[2];
	delayms(1);
		DIG0=1;DIG1=0;DIG2=0;DIG3=0;
	DIG_DATA=SMG[3];
	delayms(1);
}

void ad_da(unsigned char ch)
{
  int AD,V;
	OLED12864_ShowStr(0,0,"This is AD_DA demo  ",1);
	

			DAC_OUT_Fast(2048,1,1);
	
		AD=ADS1015_readAD(ch);		
		V=AD*3;
		OLED12864_ShowStr(0,2,"AD=",2);
		OLED12864_ShowData_int(24,2,AD,2);
		OLED12864_ShowStr(0,4,"Voltage=",2);
		OLED12864_ShowData_int(64,4,V,2);

}

void light_disp()
{
	unsigned int light;
	OLED12864_ShowStr(0,0,"This is Light demo  ",1);
	light=BH1750_Read_Data();
		OLED12864_ShowStr(0,2,"Light=",2);
		OLED12864_ShowData_uint(48,2,light,2);
		OLED12864_ShowStr(88,2,"Lx",2);
}

void press_disp()
{
	long temp,press;
	int high;
	int T;
	char i;
	unsigned char dis_buf[12];
	OLED12864_ShowStr(0,0,"This is BMP280 demo ",1);	
	while(BMP280_ReadByte(BMP280_ID_ADDR)!=BMP280_ID)		//BMP280Ƿ
	{
		OLED12864_ShowStr(0,2,"BMP280 error! ",1);
	}	
	OLED12864_ShowStr(0,2,"BMP280 Init OK",1);
		BMP280_Init();
		temp=0;
		for(i=0;i<8;i++)
		{
			press=bmp280_GetPres();
			if(temp<press)
				temp=press;
			delayms(100);
		}
		
		temp-=880;//ʵѹĲֵ
		
		high=(101325.0-temp)/133.0*12.0+0.5;	
	
		dis_buf[0]=temp/100000000+0x30;
		dis_buf[1]=temp/10000000%10+0x30;
		dis_buf[2]=temp/1000000%10+0x30;
		dis_buf[3]=temp/100000%10+0x30;
		dis_buf[4]=temp/10000%10+0x30;
		dis_buf[5]=temp/1000%10+0x30;
		dis_buf[6]=temp/100%10+0x30;
		dis_buf[7]=temp/10%10+0x30;
		dis_buf[8]=temp%10+0x30;
		dis_buf[9]='P';
		dis_buf[10]='a';
		dis_buf[11]='\0';
		OLED12864_ShowStr(0,4,dis_buf,2);
		
		OLED12864_ShowData_int(0,6,high,2);		
		OLED12864_ShowStr(48,6,"m",2);
		
		T=bmp280_GetTemp();
		OLED12864_ShowData_char(70,6,T,2);		
		OLED12864_ShowStr(102,6,"`C",2);
		delayms(10);	
		
}

void mpu6050()
{

		OLED12864_ShowStr(0,0,"This is MPU6050 demo",1);
		OLED12864_ShowData_int(0,2,MPU6050_GetData(ACCEL_XOUT_H),2);
		OLED12864_ShowData_int(0,4,MPU6050_GetData(ACCEL_YOUT_H),2);		
		OLED12864_ShowData_int(0,6,MPU6050_GetData(ACCEL_ZOUT_H),2);		
		OLED12864_ShowData_int(64,2,MPU6050_GetData(GYRO_XOUT_H),2);		
		OLED12864_ShowData_int(64,4,MPU6050_GetData(GYRO_YOUT_H),2);		
		OLED12864_ShowData_int(64,6,MPU6050_GetData(GYRO_ZOUT_H),2);	

}

void mini1602()
{
			OLED12864_ShowStr(0,0,"This is mini1602 demo",1);
	LcdShowStr(0,0,"Hello World!");
}

unsigned char state=7;

void main()
{
	OLED12864_Initial();
	BH1750_Init();
	MPU6050_init();
	t0_init();
	mini1602_init();
	while(1)
	{
			switch(state)
			{
				case 0: welcome();break;
				case 1: led_flow();break;
				case 2: SMG_disp();break;
				case 3: ad_da(0);break;
				case 4: light_disp();break;
				case 5: press_disp();break;
				case 6: mpu6050();break;
				case 7: mini1602();break;
				default:break;
			}			
		OLED12864_ShowData_uchar(0,1,num,1);
		if(flag)
		{
			OLED12864_CLS();	
			flag=0;
		}
	
	}
}

void timer0 () interrupt 1
{
	num--;
	if(num<=1)
	{
		num=200;
		state++;
		if(state>7)
			state=0;
		flag=1;
	}

	
}
